
//TPL ARDUINO Geophys-Stepper Control V1.0
#include <SPI.h>
#include "cactus_io_BME280_SPI.h"
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include "index.h"


//SW Ueberbrueckung: INPUT
#define LED0 16 //LED ggf. aus.
#define BME_SCK 5  //Clock
#define BME_MISO 4 //Data Out
#define BME_MOSI 0 //Data In
#define BME_CS 2   //Select

#define LED5 14//D-5
#define LED6 12//D-6
#define LED7 13//D-7
#define LED8 15//D-8

//Geophys Sensoren
BME280_SPI bme(BME_CS,BME_MOSI,BME_MISO,BME_SCK);//SPI


//Setting
int arrayStepsLED5[] = {1,0,0,0,};
int arrayStepsLED6[] = {0,1,0,0,};
int arrayStepsLED7[] = {0,0,1,0,};
int arrayStepsLED8[] = {0,0,0,1,};

int schalt; //D0 INNPUT_PULLUP
int brueckAnal2;
int delPara2;

const char* ssid = "your Name";
const char* password = "your Password";

ESP8266WebServer server(80);

void handleRoot() {
 String s = MAIN_page; //HTML Inhalt
 server.send(200, "text/html", s);
}
                
void softwareReset(uint8_t prescaller) {
  wdt_enable(prescaller);
  while(1) {}
  delay(1100);
  wdt_disable();
  handleRoot();
}

void resetTrue(){
softwareReset(WDTO_1S);
}

String preasure;
String humidity;
String celsius;
String fahrenheit;
void handleSensor(){
bme.readSensor();
preasure = String((float)bme.getPressure_MB()+1);
humidity = String((float)bme.getHumidity());
celsius = String((float)bme.getTemperature_C());
fahrenheit = String((float)bme.getTemperature_F());
delay(125);
}

int anal2;
String adcValue2;
String ADCValue2;
void handleADC2() {
 anal2 = analogRead(A0);
 String adcValue2 = String(anal2);
 server.send(200, "text/plane", ADCValue2=adcValue2);
}

String M2HWPara2;
int schPara2;
int repPara2;
String M2dirPara2 = "leer";
String M2schaltPara2;

void handleSchieber2() {
handleADC2(); 
M2HWPara2 = server.arg("M2set");
M2dirPara2 = server.arg("M2dir");
String statSch2 = server.arg("schieber2");
String statRep2 = server.arg("rep2");
repPara2 = statRep2.toInt();
schPara2 = statSch2.toInt();
if(M2HWPara2 == "true"){schPara2 = anal2;}
M2schaltPara2 = server.arg("M2schalt");
server.send(200, "text/plane", statSch2);
}

void handle2OFF() {
 String M2schalt = M2schaltPara2;
 if(M2schaltPara2 == "aus"){
  server.send(200, "text/plane", M2schalt);
 }
}

//SETUP
void setup() {
Serial.begin(115200);
Serial.println("TPL ARDUINO Geophys-Stepper Control V4.4ß");

 WiFi.begin(ssid, password); //WiFi router
  Serial.println("");

  //Warten auf Verbindung
  while (WiFi.status() != WL_CONNECTED) {
  delay(100);
  Serial.print(".");
  }
  Serial.print("kein WiFi");

  //Serieller Monitor
  Serial.println("");
  Serial.print("verbunden mit ");
  Serial.println(ssid);
  Serial.print("Adresse: ");
  Serial.println(WiFi.localIP());

  pinMode(LED5,OUTPUT);
  pinMode(LED6,OUTPUT);
  pinMode(LED7,OUTPUT); 
  pinMode(LED8,OUTPUT);

if (!bme.begin()) {
Serial.println("no BME280 sensor");
while (1);
}
bme.setTempCal(-1);// Sensor was reading high so offset by 1 degree C

  server.on("/", handleRoot);
  server.on("/setReset", resetTrue);
  server.on("/setPreasure", [](){handleSensor();server.send(200, "text/plane", preasure);});
  server.on("/setHumidity", [](){handleSensor();server.send(200, "text/plane", humidity);});
  server.on("/setCelsius", [](){handleSensor();server.send(200, "text/plane", celsius);});
  server.on("/setFahrenheit", [](){handleSensor();server.send(200, "text/plane", fahrenheit);});
  server.on("/readADC2", handleADC2);
  server.on("/setSchieber2", handleSchieber2);
  server.on("/setOFF2", handle2OFF);
  
//Server starten
  server.begin();
}

// LOOP
void loop() {
  server.handleClient();

//STEPPER
  if(M2schaltPara2 == "an")
  {
  for(int i = 0; i < repPara2; i++)
      {
        if(M2dirPara2 == "links"){
          
        for (int i1 = 3; i1 >= 0; i1--)
        {

//Stepper Links
        if (arrayStepsLED5[i1] == 1)
        {
          digitalWrite(LED5, HIGH);
        }
        else
        {
          digitalWrite(LED5, LOW);
        }
//
        if (arrayStepsLED6[i1] == 1)
        {
          digitalWrite(LED6, HIGH);
        }
        else
        {
          digitalWrite(LED6, LOW);
        }
//
        if (arrayStepsLED7[i1] == 1)
        {
          digitalWrite(LED7, HIGH);
        }
        else
        {
          digitalWrite(LED7, LOW);
        }
//
        if (arrayStepsLED8[i1] == 1)
        {
          digitalWrite(LED8, HIGH);
        }
        else
        {
          digitalWrite(LED8, LOW);
        }
//      
        delay(schPara2);
     }
    }


  if(M2dirPara2 == "rechts") {
    
    for (int i2 = 0; i2 < 4; i2++)
    {
      
//Stepper Rechts
        if (arrayStepsLED5[i2] == 1)
        {
          digitalWrite(LED5, HIGH);
        }
        else
        {
          digitalWrite(LED5, LOW);
        }
//
        if (arrayStepsLED6[i2] == 1)
        {
          digitalWrite(LED6, HIGH);
        }
        else
        {
          digitalWrite(LED6, LOW);
        }
//
        if (arrayStepsLED7[i2] == 1)
        {
          digitalWrite(LED7, HIGH);
        }
        else
        {
          digitalWrite(LED7, LOW);
        }
//
        if (arrayStepsLED8[i2] == 1)
        {
          digitalWrite(LED8, HIGH);
        }
        else
        {
          digitalWrite(LED8, LOW);
        }
//    
        delay(schPara2);
    }
   }

    digitalWrite(LED5, LOW);
    digitalWrite(LED6, LOW);
    digitalWrite(LED7, LOW);
    digitalWrite(LED8, LOW);

       if(i == repPara2-1 && schalt == 0){
       M2schaltPara2 = "aus";
       handle2OFF();
       repPara2 = 0;} 
   }
 } 
} 

