/*
=================================================
|TPL IN/OUT Control mit 433MHz Empfaenger  V1.0ß|
|                                               |
|        an Arduino "NodeMCU Lolin V3",         |
| Sender-/Empfaenger-Set Modell: "MX- FS- 03V"  |
|                                               |
|     WiFi, HTML & JavaScript kontrolliert      |
|  (FireFox und IE 10 mit Windows 10 getestet)  |
|                                               |
| Fuer Boardtest & zeitunkritische  Anwendungen |
| ACHTUNG:  Reaktionzeiten  des Statustwechsels |
| in BetaVersion je nach Browser/Betriebssystem |
|                  2 - 20 sec.                  |
|                                               |
|   (c) TPL Consulting, Thomas P. Ledwon 2018   |
|             www.tplconsulting.com             |
=================================================
 */

 
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>

#include <RCSwitch.h>
#include "index.h"

#define LED0 16 //On board LED
#define LED1 5
#define LED2 4
#define LED3 0 
#define LED4 2  //On board LED
#define LED5 14
#define LED6 12
#define LED7 13
#define LED8 15

uint8_t GPIO_Pin = D3;
int code;
char  cstr;
RCSwitch rcSwitch = RCSwitch();

//SSID Password WiFi router
const char* ssid = "your Name";
const char* password = "your Password";
 
ESP8266WebServer server(80); //Server on port 80


 
//=========================================
//            Browser öffnen
//=========================================


void handleRoot() {
 String s = MAIN_page; //HTML Inhalt
 server.send(200, "text/html", s);
}


void handleADC() {
 int a = analogRead(A0);
 String adcValue = String(a);
 server.send(200, "text/plane", adcValue);
}

void handleADC1() {
 int aa = analogRead(A0);
 float  aaa = aa * (5.0 / 1023.0);
 String adcValue1 = String(aaa);
 server.send(200, "text/plane", adcValue1);
}


String schalt = "aus";

String bit0;
void handleLED0() {
 String ledState0 = "OFF";
 String t_state = server.arg("LED0state");
 if(bit0 == "1" || t_state == "1")
 {
  digitalWrite(LED0,HIGH);
  ledState0 = "ON";
 }
 else if(bit0 == "0")
 {
  digitalWrite(LED0,LOW);
  ledState0 = "OFF";  
 }
 else{ledState0 = "NA";}
 Serial.println(" ");
 Serial.println("geschaltet:");
 Serial.print("Bit 0: ");Serial.println(ledState0);
 schalt = "ein";
 server.send(200, "text/plane", ledState0);
}


String bit1;
void handleLED1() {
 String ledState1 = "OFF";
 String t_state = server.arg("LED1state");
 if(bit1 == "1" || t_state == "1")
 {
  digitalWrite(LED1,HIGH);
  ledState1 = "ON";
 }
 else if(bit1 == "0")
 {
  digitalWrite(LED1,LOW);
  ledState1 = "OFF";  
 }
 else{ledState1 = "NA";}
 Serial.print("Bit 1: ");Serial.println(ledState1);
 schalt = "ein";
 server.send(200, "text/plane", ledState1);
}


String bit2;
void handleLED2() {
String ledState2 = "OFF";
 String t_state = server.arg("LED2state");
 if(bit2 == "1" || t_state == "1")
 {
  digitalWrite(LED2,HIGH);
  ledState2 = "ON";
 }
 else if(bit2 == "0")
 {
  digitalWrite(LED2,LOW);
  ledState2 = "OFF";  
 }
 else{ledState2 = "NA";}
 Serial.print("Bit 2: ");Serial.println(ledState2);
 schalt = "ein";
 server.send(200, "text/plane", ledState2);
}


String bit3;
void handleLED3() {
 String ledState3 = "OFF";
 String t_state = server.arg("LED3state");
 if(bit3 == "1" || t_state == "1")
 {
 //digitalWrite(LED3,HIGH);
  ledState3 = "ON";
 }
 else if(bit3 == "0")
 {
  //digitalWrite(LED3,LOW);
  ledState3 = "OFF";  
 }
 else{ledState3 = "NA";}
 Serial.print("Bit 3: ");Serial.print(ledState3);Serial.println(" (Interrupt)");
 schalt = "ein";
 server.send(200, "text/plane", ledState3);
}


String bit4;
void handleLED4() {
 String ledState4 = "aus";
 String t_state = server.arg("LED4state");
 if(bit4 == "1" || t_state == "1")
 {
  digitalWrite(LED4,HIGH);
  ledState4 = "an";
 }
 else if(bit4 == "0")
 {
  digitalWrite(LED4,LOW);
  ledState4 = "aus";  
 }
 else{ledState4 = "NA";}
 Serial.print("Bit 4: ");Serial.println(ledState4);
 schalt = "ein";
 server.send(200, "text/plane", ledState4);
}


String bit5;
void handleLED5() {
 String ledState5 = "OFF";
 String t_state = server.arg("LED5state");
 if(bit5 == "1" || t_state == "1")
 {
  digitalWrite(LED5,HIGH);
  ledState5 = "ON";
 }
 else if(bit5 == "0")
 {
  digitalWrite(LED5,LOW);
  ledState5 = "OFF";  
 }
 else{ledState5 = "NA";}
 Serial.print("Bit 5: ");Serial.println(ledState5);
 schalt = "ein";
 server.send(200, "text/plane", ledState5);
}


String bit6;
void handleLED6() {
 String ledState6 = "OFF";
 String t_state = server.arg("LED6state");
 if(bit6 == "1" || t_state == "1")
 {
  digitalWrite(LED6,HIGH);
  ledState6 = "ON";
 }
 else if(bit6 == "0")
 {
  digitalWrite(LED6,LOW);
  ledState6 = "OFF";  
 }
 else{ledState6 = "NA";}
 Serial.print("Bit 6: ");Serial.println(ledState6);
 schalt = "ein";
 server.send(200, "text/plane", ledState6);
}


String bit7;
void handleLED7() {
 String ledState7 = "OFF";
 String t_state = server.arg("LED7state");
 if(bit7 == "1" || t_state == "1")
 {
  digitalWrite(LED7,HIGH);
  ledState7 = "ON";
 }
 else if(bit7 == "0")
 {
  digitalWrite(LED7,LOW);
  ledState7 = "OFF";  
 }
 else{ledState7 = "NA";}
 Serial.print("Bit 7: ");Serial.println(ledState7);
 schalt = "ein";
 server.send(200, "text/plane", ledState7);
}


String bit8;
void handleLED8() {
 String ledState8 = "OFF";
 String t_state = server.arg("LED8state");
 if(bit8 == "1" || t_state == "1")
 {
  digitalWrite(LED8,HIGH);
  ledState8 = "ON";
 }
 else if(bit8 == "0")
 {
  digitalWrite(LED8,LOW);
  ledState8 = "OFF";  
 }
 else{ledState8 = "NA";}
 Serial.print("Bit 8: ");Serial.println(ledState8);
 schalt = "ein";
 server.send(200, "text/plane", ledState8);
}


void handleDim(){
int a;
String clip = server.arg("ANAstate");
int clipping1 = clip.toInt();

Serial.println(clipping1);


            do{a = analogRead(A0);
            if(a < 20){clipping1 = 0;}
                     digitalWrite(LED0,HIGH);
                     delay(a);
                     digitalWrite(LED0,LOW);
                     delay(a);      
                    }while(clipping1 == 1);

                    Serial.println(a);
                       
       server.send(200, "text/plane", clip);
}


String codeRet ="0 0 0 0 0 0 0 0 0";
void bStatus(){
String bitStat = server.arg("bitState");
bitStat = String(codeRet);
server.send(200, "text/plane", bitStat);
}

String anaRet ="0 0 0 0";
void anaStatus(){
String anaStat = server.arg("anaStat");
anaStat = String(anaRet);
server.send(200, "text/plane", anaStat);
}

//============================================
//                  SETUP
//============================================

  void setup(void){
  Serial.begin(115200);
  
  WiFi.begin(ssid, password); //WiFi router
  Serial.println("");
 
 //Port auf Ausgang
  pinMode(LED0,OUTPUT);
  pinMode(LED1,OUTPUT);
  pinMode(LED2,OUTPUT); 
  pinMode(LED3,INPUT); 
  pinMode(LED4,OUTPUT); //blaue LED
  pinMode(LED5,OUTPUT);
  pinMode(LED6,OUTPUT);
  pinMode(LED7,OUTPUT); 
  pinMode(LED8,OUTPUT);  

   
  //Warten auf Verbindung
  while (WiFi.status() != WL_CONNECTED) {
    delay(100);
    Serial.print(".");
  }
 
  //Serieller Monitor
  Serial.println("");
  Serial.print("433 MHz-EMPFAENGER verbunden mit ");
  Serial.println(ssid);
  Serial.print("IP Adresse: ");
  Serial.println(WiFi.localIP());
    

//Routinenaufruf

  server.on("/", handleRoot);

  server.on("/readADC", handleADC);
  server.on("/readADC1", handleADC1);

  server.on("/setLED0", handleLED0);
  server.on("/setLED1", handleLED1); 
  server.on("/setLED2", handleLED2);
  server.on("/setLED3", handleLED3); 
  server.on("/setLED4", handleLED4);
  server.on("/setLED5", handleLED5); 
  server.on("/setLED6", handleLED6);
  server.on("/setLED7", handleLED7); 
  server.on("/setLED8", handleLED8);

  server.on("/ANA_stat", handleDim);
  server.on("/setbStatus", bStatus);
  server.on("/setanaStatus", anaStatus);
  
  rcSwitch.enableReceive(GPIO_Pin); 
      
  server.begin();                //Server starten
  
}

//===============================================
//                     LOOP
//===============================================

void loop(void){

 if (rcSwitch.available()){

    int code = rcSwitch.getReceivedValue();
    
    rcSwitch.resetAvailable();

    if(code < 1025){
  //Analog A0
    Serial.print("analog A0 : ");Serial.println(code);
    anaRet = String(code);
    }
    else{ 
    Serial.println("");
    Serial.print("empfangen, Steuer-Bit & BIT 0 - 8: ");Serial.print(code);
    Serial.println("");

  //Bit 0 - 8
    char  cstr[10]; 
    itoa(code, cstr, 10);
    
    bit0 = cstr[1];
    bit1 = cstr[2];
    bit2 = cstr[3];
    bit3 = cstr[4];
    bit4 = cstr[5];
    bit5 = cstr[6];
    bit6 = cstr[7];
    bit7 = cstr[8];
    bit8 = cstr[9];
  
    Serial.print("bit0 : ");Serial.println(bit0);
    Serial.print("bit1 : ");Serial.println(bit1);
    Serial.print("bit2 : ");Serial.println(bit2);
    Serial.print("bit3 : ");Serial.println(bit3);
    Serial.print("bit4 : ");Serial.println(bit4);
    Serial.print("bit5 : ");Serial.println(bit5);
    Serial.print("bit6 : ");Serial.println(bit6);
    Serial.print("bit7 : ");Serial.println(bit7);
    Serial.print("bit8 : ");Serial.println(bit8);

    codeRet = String(bit0 + " " + bit1 + " " + bit2 + " " + bit3 + " " + bit4 + " " + bit5 + " " + bit6 + " " + bit7 + " " +  bit8);
    }

 
  }
   
 server.handleClient();  //Handle Client Anfrage
}
