#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET D5
/* Object named display, of the class Adafruit_SSD1306 */
Adafruit_SSD1306 display(OLED_RESET);

#if (SSD1306_LCDHEIGHT != 64)
#error("Height incorrect, please fix Adafruit_SSD1306.h!");
#endif


#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include "index.h"

#define LED0 16 

#define LED1 5
#define LED2 4
#define LED3 0 
#define LED4 2  //On board LED
#define LED5 14
#define LED6 12
#define LED7 13
#define LED8 15
#define LED9 3
#define LED10 1

int ergbA = 0;
int ergbB;
int setA = 0;

int schalt; // SW-Bruecke. HE-Schalter (D0 INNPUT_PULLUP)
int brueckAnal2 = analogRead(A0);
int delPara2;

const int analogInPin = A0;
int sensorValue = 0;
unsigned long int avgValue;
float b;
int buf[10],temp;
float phValue = 00.00;

const char* ssid = "your Name";
const char* password = "your Password";

ESP8266WebServer server(80);

void handleRoot() {
 String s = MAIN_page; //HTML Inhalt
 server.send(200, "text/html", s);
}

void softwareReset(uint8_t prescaller) {
  wdt_enable(prescaller);
  while(1) {}
  delay(1100);
  wdt_disable();
  handleRoot();
}

void resetTrue(){
softwareReset(WDTO_1S);
}

String preasureF;
String preasure;
void handleSensor(){
phValue = analogRead(analogInPin);
preasure = String((float)phValue);
delay(20);
handleADC2();
server.send(200, "text/plane", preasure);
}

String M2dirPara2 = "leer";
int schPara2;
String Act11 = "set";
int anal2V;
int anal2;
String adcValue2;
String ADCValue2;
void handleADC2() {
 if(Act11 != "false"){ 
 anal2 = analogRead(A0);
 anal2V = analogRead(A0);}
  else{
    if(M2dirPara2 == "links"){anal2 = 1024-schPara2;}else{anal2 = schPara2;}
    }
 String adcValue2 = String(anal2);
 writeOLED();
 server.send(200, "text/plane", ADCValue2=adcValue2);
}

//String Act11 = "set";
String M2HWPara2;
//int schPara2;
int delMax2;
int repPara2 = 1;
//String M2dirPara2 = "leer";
String M2schaltPara2;
int max2;
int val1;
int val2;
void handleSchieber2() {
Act11 = server.arg("Act11");
handleADC2();
M2HWPara2 = server.arg("M2set");
M2dirPara2 = server.arg("M2dir");
String statSch2 = server.arg("schieber2");
String statRep2 = server.arg("rep2");
repPara2 = statRep2.toInt();
schPara2 = statSch2.toInt();
String maxT = server.arg("maxMot2");
max2 = maxT.toInt();
if(M2HWPara2 == "true"){val1 = statSch2.toInt();statSch2=val1;}else{val2 = statSch2.toInt();statSch2=val2;}
delMax2=max2-schPara2;
M2schaltPara2 = server.arg("M2schalt");
Serial.println(val1);Serial.println(val2);Serial.println(Act11);
server.send(200, "text/plane", statSch2);
}

void handle2OFF() {
 String M2schalt = M2schaltPara2;
 if(M2schaltPara2 == "aus"){
  server.send(200, "text/plane", M2schalt);
  return;
 }
}


void drawStr(uint8_t x, uint8_t y, char* str){
  display.setCursor(x, y);  /* Set x,y coordinates */
  display.println(str);
}

void writeOLED(){
  int strV = adcValue2.length() +1;
  enum{BufS = 5};
  char buf[BufS];
  snprintf(buf, BufS, "%d", anal2);
  display.clearDisplay();  /* Clear display */
  drawStr(5, 5, "Light Sensor Control");
  drawStr(5, 27, "anal.");
  display.setTextSize(2);
  if(strV == 5){drawStr(42, 25, buf);}else{drawStr(42, 25, "0");drawStr(54, 25, buf);}
  display.setTextSize(1);
  drawStr(99, 27, "dez.");
  drawStr(24, 55, "TPL Consulting");
  display.display();
}


void setup(void)
{
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); /* Initialize display with address 0x3C */
  display.clearDisplay();  /* Clear display */
  display.setTextSize(1);  /* Select font size of text. Increases with size of argument. */
  display.setTextColor(WHITE);  /* Color of text*/

Serial.begin(115200);

Serial.println("TPL ARDUINO Geophys-Stepper Control V4.4ß");

 WiFi.begin(ssid, password); //WiFi router
  Serial.println("");

  //Warten auf Verbindung
  while (WiFi.status() != WL_CONNECTED) {
  delay(100);
  Serial.print(".");
  }
  Serial.print("kein WiFi");

  

  //Serieller Monitor
  Serial.println("");
  Serial.print("verbunden mit ");
  Serial.println(ssid);
  Serial.print("Adresse: ");
  Serial.println(WiFi.localIP());

  //Ports auf Ausgang
  pinMode(LED0,OUTPUT); //blaue LED
  digitalWrite(LED0, LOW);
  pinMode(LED1,OUTPUT);
  pinMode(LED2,OUTPUT); 
  pinMode(LED3,OUTPUT);
  pinMode(LED4,OUTPUT); //blaue LED
  pinMode(LED5,OUTPUT);
  digitalWrite(LED5, LOW);
  pinMode(LED6,OUTPUT);
  digitalWrite(LED6, LOW);
  pinMode(LED7,OUTPUT);
  digitalWrite(LED7, LOW); 
  pinMode(LED8,OUTPUT);
  digitalWrite(LED8, LOW);
  pinMode(LED9,INPUT_PULLUP);//Rx
  //pinMode(LED10,OUTPUT);//Tx 

  server.on("/", handleRoot);
  server.on("/setReset", resetTrue);
  server.on("/setPreasure", handleSensor);
  server.on("/readADC2", handleADC2);
  server.on("/setSchieber2", handleSchieber2);
  server.on("/setOFF2", handle2OFF);
  
  //Server starten
  server.begin();
}


void loop() {

    digitalWrite(LED0, LOW);
    digitalWrite(LED5, LOW);
    digitalWrite(LED7, LOW);
    digitalWrite(LED6, LOW);
    digitalWrite(LED8, LOW);
    digitalRead(LED9);
    digitalWrite(LED10, LOW);
    
  server.handleClient();
  
  

  if (digitalRead(LED9) == 0 && Act11 == "false"){ 
  M2schaltPara2 = "aus";handle2OFF();M2schaltPara2 = "an";
  if(M2dirPara2 == "links"){M2dirPara2 = "rechts";}else{M2dirPara2 = "links";}
  repPara2=1;schPara2=20;delMax2=25;delay(20);
  }

  
  
if(M2schaltPara2 == "an" && Act11 == "false"){
  digitalWrite(LED0, HIGH);
  for(int i = 0; i < repPara2; i++){
    
   if(M2dirPara2 == "links"){
    if(M2HWPara2 != "true"){Serial.print("manuell");
      digitalWrite(LED5, HIGH);
      delay(7);
      digitalWrite(LED5, LOW);
      delay(50);
      }
      else{
      digitalWrite(LED7, HIGH);
      delay(8);
      digitalWrite(LED7, LOW);
      delay(10);
      }
    }
      
    if(M2dirPara2 == "rechts"){
      if(M2HWPara2 != "true"){
      digitalWrite(LED6, HIGH);
      delay(7);
      digitalWrite(LED6, LOW);
      delay(50);
      }
      else{ 
      digitalWrite(LED8, HIGH);
      delay(8);
      digitalWrite(LED8, LOW);
      delay(10);
      }
    }
    
    if (digitalRead(LED9) == 0){i = repPara2;break;}
  }
    M2schaltPara2 = "aus";
    digitalWrite(LED0, LOW);
    handle2OFF();
    //Act11="true";
}






  
  if(Act11 == "true"){
  digitalWrite(LED0, HIGH);

  ergbB = setA;
  setA = round((analogRead(A0))/12);
  
    ergbA = (setA-ergbB);
    Serial.println(" ");
    Serial.print(setA);Serial.print(", ");Serial.print(ergbA);

    delay(1000);
    
if(ergbA > 0){
  for(int i = 0; i < ergbA; i++){
      digitalWrite(LED5, HIGH);
      delay(7);
      digitalWrite(LED5, LOW);
      delay(50);
      if (digitalRead(LED9) == 0){break;}
      }
    }


if(ergbA < 0){
  for(int i = 0; i < abs(ergbA); i++){
      digitalWrite(LED6, HIGH);
      delay(7);
      digitalWrite(LED6, LOW);
      delay(50);
      if (digitalRead(LED9) == 0){break;}
      }
    }
  }


  if(Act11 == "set"){
    digitalWrite(LED0, HIGH);
    Serial.println("M1");
     for(int im1 = 0; im1 < 1024; im1++){
      Serial.println(im1);
      digitalWrite(LED5, HIGH);
      delay(8);
      digitalWrite(LED5, LOW);
      delay(100);
      if (digitalRead(LED9) == 0){break;}
    }

      digitalWrite(LED6, HIGH);
      delay(15);
      digitalWrite(LED6, LOW);
      delay(100);
      
      Serial.println("M2");
     for(int im2 = 0; im2 < 20; im2++){
      Serial.println(im2);
      digitalWrite(LED7, HIGH);
      delay(8);
      digitalWrite(LED7, LOW);
      delay(100);
      if (digitalRead(LED9) == 0){break;}
      }

      digitalWrite(LED8, HIGH);
      delay(8);
      digitalWrite(LED8, LOW);
      delay(100);
      
    int setA1 = round((1024-analogRead(A0))/6);

    for(int im1r = 0; im1r < setA1; im1r++){
      Serial.print(setA1);Serial.println(" = ");Serial.println(im1r);
      digitalWrite(LED6, HIGH);
      delay(7);
      digitalWrite(LED6, LOW);
      delay(50);
      
      if (digitalRead(LED9) == 0){break;}

      digitalWrite(LED8, HIGH);
      delay(8);
      digitalWrite(LED8, LOW);
      delay(100);

      if (digitalRead(LED9) == 0){break;}
    }

      digitalWrite(LED5, HIGH);
      delay(7);
      digitalWrite(LED5, LOW);
      delay(50);

      digitalWrite(LED7, HIGH);
      delay(8);
      digitalWrite(LED7, LOW);
      delay(100);
    
    M2schaltPara2 = "aus";
    digitalWrite(LED0, LOW);
    handle2OFF();
    Act11="true";
   }
   
}

