
#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
 
#include "index.h"

#define LED0 16 //On board LED
#define LED1 5
#define LED2 4
#define LED3 0 
#define LED4 2  //On board LED
#define LED5 14
#define LED6 12
#define LED7 13
#define LED8 15


//SSID Password WiFi router
const char* ssid = "your Name";
const char* password = "your Password";
 
ESP8266WebServer server(80); //Server on port 80


 
//=========================================
//            Browser öffnen
//=========================================


void handleRoot() {
 String s = MAIN_page; //HTML Inhalt
 server.send(200, "text/html", s);
}


void handleADC() {
 int a = analogRead(A0);
 String adcValue = String(a);
 server.send(200, "text/plane", adcValue);
}

void handleADC1() {
 int aa = analogRead(A0);
 float  aaa = aa * (5.0 / 1023.0);
 String adcValue1 = String(aaa);
 server.send(200, "text/plane", adcValue1);
}


void handleLED0() {
 String ledState0 = "OFF";
 String t_state = server.arg("LED0state");
 
 if(t_state == "1")
 {
  digitalWrite(LED0,HIGH);
  ledState0 = "ON";
 }
 else
 {
  digitalWrite(LED0,LOW);
  ledState0 = "OFF";  
 }
 server.send(200, "text/plane", ledState0);
}


void handleLED1() {
 String ledState1 = "OFF";
 String t_state = server.arg("LED1state");
 
 if(t_state == "1")
 {
  digitalWrite(LED1,HIGH);
  ledState1 = "ON";
 }
 else
 {
  digitalWrite(LED1,LOW);
  ledState1 = "OFF";  
 }
 server.send(200, "text/plane", ledState1);
}


void handleLED2() {
 String ledState2 = "OFF";
 String t_state = server.arg("LED2state");
 
 if(t_state == "1")
 {
  digitalWrite(LED2,HIGH);
  ledState2 = "ON";
 }
 else
 {
  digitalWrite(LED2,LOW);
  ledState2 = "OFF";  
 }
 server.send(200, "text/plane", ledState2);
}


void handleLED3() {
 String ledState3 = "OFF";
 String t_state = server.arg("LED3state"); 
 
 if(t_state == "1")
 {
  digitalWrite(LED3,HIGH);
  ledState3 = "ON"; 
 }
 else
 {
  digitalWrite(LED3,LOW); 
  ledState3 = "OFF"; 
 }
 server.send(200, "text/plane", ledState3);
}


void handleLED4() {
 String ledState4 = "aus";
 String t_state = server.arg("LED4state");
 
 if(t_state == "1")
 {
  digitalWrite(LED4,HIGH);
  ledState4 = "an"; 
 }
 else
 {
  digitalWrite(LED4,LOW);
  ledState4 = "aus";  
 }
 server.send(200, "text/plane", ledState4);
}

void handleLED5() {
 String ledState5 = "aus";
 String t_state = server.arg("LED5state");
 
 if(t_state == "1")
 {
  digitalWrite(LED5,HIGH);
  ledState5 = "ON"; 
 }
 else
 {
  digitalWrite(LED5,LOW);
  ledState5 = "OFF";  
 }
 server.send(200, "text/plane", ledState5);
}

void handleLED6() {
 String ledState6 = "ON";
 String t_state = server.arg("LED6state");
 
 if(t_state == "1")
 {
  digitalWrite(LED6,HIGH);
  ledState6 = "ON"; 
 }
 else
 {
  digitalWrite(LED6,LOW);
  ledState6 = "OFF";  
 }
 server.send(200, "text/plane", ledState6);
}

void handleLED7() {
 String ledState7 = "ON";
 String t_state = server.arg("LED7state");
 
 if(t_state == "1")
 {
  digitalWrite(LED7,HIGH);
  ledState7 = "ON"; 
 }
 else
 {
  digitalWrite(LED7,LOW);
  ledState7 = "OFF";  
 }
 server.send(200, "text/plane", ledState7);
}

void handleLED8() {
 String ledState8 = "ON";
 String t_state = server.arg("LED8state");
 if(t_state == "1")
 {
  digitalWrite(LED8,HIGH);
  ledState8 = "ON"; 
 }
 else
 {
  digitalWrite(LED8,LOW);
  ledState8 = "OFF";  
 }
 server.send(200, "text/plane", ledState8);
}

void handleDim(){
int a;
String clip = server.arg("ANAstate");
int clipping1 = clip.toInt();

Serial.println(clipping1);


            do{a = analogRead(A0);
            if(a < 20){clipping1 = 0;}
                     digitalWrite(LED0,HIGH);
                     delay(a);
                     digitalWrite(LED0,LOW);
                     delay(a);      
                    }while(clipping1 == 1);

                    Serial.println(a);
                       
       server.send(200, "text/plane", clip);
}


//============================================
//                  SETUP
//============================================

  void setup(void){
  Serial.begin(115200);
  
  WiFi.begin(ssid, password); //WiFi router
  Serial.println("");
 
 //Port auf Ausgang
  pinMode(LED0,OUTPUT);
  pinMode(LED1,OUTPUT);
  pinMode(LED2,OUTPUT); 
  pinMode(LED3,OUTPUT); 
  pinMode(LED4,OUTPUT); //blaue LED
  pinMode(LED5,OUTPUT);
  pinMode(LED6,OUTPUT);
  pinMode(LED7,OUTPUT); 
  pinMode(LED8,OUTPUT);  

   
  //Warten auf Verbindung
  while (WiFi.status() != WL_CONNECTED) {
    delay(100);
    Serial.print(".");
  }
 
  //Serieller Monitor
  Serial.println("");
  Serial.print("verbunden mit ");
  Serial.println(ssid);
  Serial.print("IP Adresse: ");
  Serial.println(WiFi.localIP());
    

//Routinenaufruf

  server.on("/", handleRoot);

  server.on("/readADC", handleADC);
  server.on("/readADC1", handleADC1);

  server.on("/setLED0", handleLED0);
  server.on("/setLED1", handleLED1); 
  server.on("/setLED2", handleLED2);
  server.on("/setLED3", handleLED3); 
  server.on("/setLED4", handleLED4);
  server.on("/setLED5", handleLED5); 
  server.on("/setLED6", handleLED6);
  server.on("/setLED7", handleLED7); 
  server.on("/setLED8", handleLED8);

  server.on("/ANA_stat", handleDim);
  
  server.begin();                //Server starten
}

//===============================================
//                     LOOP
//===============================================
void loop(void){

 
  server.handleClient();  //Handle Client Anfrage
  
}
