#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET D5
/* Object named display, of the class Adafruit_SSD1306 */
Adafruit_SSD1306 display(OLED_RESET);

#if (SSD1306_LCDHEIGHT != 64)
#error("Height incorrect, please fix Adafruit_SSD1306.h!");
#endif

uint8_t s = 0, m = 0, h = 0;

#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include "index.h"

#define LED0 16 

#define LED1 5
#define LED2 4
#define LED3 0 
#define LED4 2  //On board LED
#define LED5 14
#define LED6 12
#define LED7 13
#define LED8 15



int schalt; // SW-Bruecke. HE-Schalter (D0 INNPUT_PULLUP)
int brueckAnal2 = analogRead(A0);
int delPara2;

const int analogInPin = A0;
int sensorValue = 0;
unsigned long int avgValue;
float b;
int buf[10],temp;
float phValue = 00.00;

const char* ssid = "your Name";
const char* password = "your Password";

ESP8266WebServer server(80);

void handleRoot() {
 String s = MAIN_page; //HTML Inhalt
 server.send(200, "text/html", s);
}

void softwareReset(uint8_t prescaller) {
  wdt_enable(prescaller);
  while(1) {}
  delay(1100);
  wdt_disable();
  handleRoot();
}

void resetTrue(){
softwareReset(WDTO_1S);
}

String sevenSet;
void handleSeven(){
  sevenSet= server.arg("sevenChk");
  Serial.println(sevenSet);
  return;
}


String phOffset= "33.11";
void handlePhoff(){
  phOffset = server.arg("OFFset");
}


String preasure;
void handleSensor(){
preasure = String((float)phValue);

for(int i=0;i<10;i++)
 {
 if(sevenSet == "calibrate pH"){buf[i]=515;}else{buf[i]=analogRead(analogInPin);}
 delay(20);
}
for(int i=0;i<9;i++)
{
 for(int j=i+1;j<10;j++)
 {
  if(buf[i]>buf[j])
  {
   temp=buf[i];
   buf[i]=buf[j];
   buf[j]=temp;
  }
 }
}

Serial.println(phOffset);
avgValue=0;
for(int i=2;i<8;i++)avgValue+=buf[i];

float pHVol=(float)avgValue*5.0/1024/6;
if(phOffset != "0.00"){
phValue = pHVol + phOffset.toFloat(); //-5.70 und + 34.31 normal (offset = 2.28)
Serial.print("Sensor = ");
Serial.println(phValue);
}

writeOLED();
delay(20);// 20 normal
server.send(200, "text/plane", preasure);
}


int anal2;
String adcValue2;
String ADCValue2;
void handleADC2() {
 anal2 = analogRead(A0);
 String adcValue2 = String(anal2);
 server.send(200, "text/plane", ADCValue2=adcValue2);
}


String M2HWPara2;
int schPara2;
int delMax2;
int repPara2=1;
String M2dirPara2 = "leer";
String M2schaltPara2;
int max2;
void handleSchieber2() {
handleADC2(); 
M2HWPara2 = server.arg("M2set");
M2dirPara2 = server.arg("M2dir");
String statSch2 = server.arg("schieber2");
String statRep2 = server.arg("rep2");
repPara2 = statRep2.toInt();
schPara2 = statSch2.toInt();
String maxT = server.arg("maxMot2");
max2 = maxT.toInt();
delMax2=max2-schPara2;
if(M2HWPara2 == "true"){schPara2 = anal2;}
M2schaltPara2 = server.arg("M2schalt");
server.send(200, "text/plane", statSch2);
}

void handle2OFF() {
 String M2schalt = M2schaltPara2;
 if(M2schaltPara2 == "aus"){
  server.send(200, "text/plane", M2schalt);
 }
}


void drawStr(uint8_t x, uint8_t y, char* str){
  display.setCursor(x, y);  /* Set x,y coordinates */
  display.println(str);
}

void writeOLED(){
  int strV = preasure.length() +1;
  enum{BufS = 7};
  char buf[BufS];
  snprintf(buf, BufS, "%.2f", phValue);
  display.clearDisplay();  /* Clear display */
  drawStr(18, 5, "pH Value Control");
  display.setTextSize(2);
  if(strV == 6){drawStr(32, 25, buf);}else{drawStr(32, 25, "0");drawStr(45, 25, buf);}
  display.setTextSize(1);
  drawStr(97, 27, "pH");
  drawStr(24, 55, "TPL Consulting");
  display.display();
}


void setup(void)
{
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C); /* Initialize display with address 0x3C */
  display.clearDisplay();  /* Clear display */
  display.setTextSize(1);  /* Select font size of text. Increases with size of argument. */
  display.setTextColor(WHITE);  /* Color of text*/

Serial.begin(115200);

Serial.println("TPL ARDUINO Geophys-Stepper Control V4.4ß");

 WiFi.begin(ssid, password); //WiFi router
  Serial.println("");

  //Warten auf Verbindung
  while (WiFi.status() != WL_CONNECTED) {
  delay(100);
  Serial.print(".");
  }
  Serial.print("kein WiFi");

  //Serieller Monitor
  Serial.println("");
  Serial.print("verbunden mit ");
  Serial.println(ssid);
  Serial.print("Adresse: ");
  Serial.println(WiFi.localIP());

    //Port auf Ausgang
 // pinMode(LED0,INPUT_PULLUP);
  pinMode(LED0,OUTPUT); //blaue LED
  pinMode(LED1,OUTPUT);
  pinMode(LED2,OUTPUT); 
  pinMode(LED3,OUTPUT);
  pinMode(LED4,OUTPUT); //blaue LED
  pinMode(LED5,OUTPUT);
  pinMode(LED6,OUTPUT);
  pinMode(LED7,OUTPUT); 
  pinMode(LED8,OUTPUT); 

  server.on("/", handleRoot);
  server.on("/setReset", resetTrue);
  server.on("/setPreasure", handleSensor);
  server.on("/readADC2", handleADC2);
  server.on("/setSchieber2", handleSchieber2);
  server.on("/setOFF2", handle2OFF);
  server.on("/setphOFF",handlePhoff);
  server.on("/sevenGo",handleSeven);
  
  //Server starten
  server.begin();
}


void loop() {


  server.handleClient();
  
  if(M2schaltPara2 == "an"){

  for(int i = 0; i < repPara2; i++)
      {

  if(M2dirPara2 == "links"){
    digitalWrite(LED5, HIGH);
    digitalWrite(LED7, HIGH);
    delay(schPara2);
    digitalWrite(LED5, LOW);
    digitalWrite(LED7, LOW);
    delay(delMax2);
      }
      
    if(M2dirPara2 == "rechts"){
    digitalWrite(LED6, HIGH);
    digitalWrite(LED8, HIGH);
    delay(schPara2);
    digitalWrite(LED6, LOW);
    digitalWrite(LED8, LOW);
    delay(schPara2);
      }
    
    }
    digitalWrite(LED5, LOW);
    digitalWrite(LED6, LOW);
    digitalWrite(LED7, LOW);
    digitalWrite(LED8, LOW);
    M2schaltPara2 = "aus";

    handle2OFF();
  }
}
